<?php

/*******************************************
 *                                         *
 *     Filmverwaltung mit PHP & MySQL      *
 *                                         *
 *******************************************
 *                                         *
 * Copyright: ab 2005 Dominik Erdmann      *
 *  Internet: www.der-domi.de              *
 *     Email: kontakt@der-domi.de          *
 *                                         *
 *******************************************
 *                                         *
 * Das Skript darf nach eigenem Belieben   *
 * gendert werden. Copyright-Hinweise und *
 * Links auf www.der-domi.de drfen nicht  *
 * verndert werden und mssen jederzeit   *
 * sichtbar bleiben!                       *
 *                                         *
 *******************************************
 */

/*
 * Installationsskript
 */


// includes
require("../settings/admin.php");
require("../settings/php.php");
require("../classes/class.ctlVar.php");
require("../classes/class.db.php");
require("../classes/class.out.php");
require("../classes/class.phpmailer.php");
require("../classes/class.settings.php");
require("../includes/functions.php");
require("../includes/funcOutput.php");

$myDB  = new db($server, $username, $pass, $dbase, $prefix, $MySQL_Ver);
$out   = new out( "  ", 0 );
$settings = new settings( $myDB, TRUE );
$settings->standardStyle = "../styles/style01.css";
$settings->browserTitel = "Filmverwaltung mit PHP &amp; MySQL";
$myVar = new ctlVar($settings,$myDB,$COOCKIES_ACTIVE,TRUE);


//$myVar->crtlGetPostData( $myDB, $settings );
$out->startBuffer();

if ( isset($_REQUEST['sent']) )
{
        // neue Tabellen erstellen
        if ($_REQUEST['His'] == 1) {
            $sql = "CREATE TABLE IF NOT EXISTS $myDB->HISTORY (HistoryID int(10) unsigned NOT NULL auto_increment, FILME_FilmID int(10) unsigned NOT NULL, USERS_UserID int(10) unsigned NOT NULL, ausgeliehenAm date NOT NULL default '0000-00-00', zurueckgegebenAm date NOT NULL default '0000-00-00', PRIMARY KEY (HistoryID), KEY FILME_FilmID (FILME_FilmID, USERS_UserID))";
            $rs = $myDB->go($sql);
            $sql2 = "SELECT FILME_FilmID, USERS_UserID, ausgeliehenAm FROM $myDB->DISCS WHERE ausgeliehenAm !='0000-00-00'";
            $rs2 = $myDB->go($sql2);
            while ( $row2 = $myDB->getRow($rs2)) {
                $sql3 = "INSERT INTO $myDB->HISTORY (FILME_FilmID, USERS_UserID, ausgeliehenAm) VALUES ({$row2['FILME_FilmID']}, {$row2['USERS_UserID']}, '{$row2['ausgeliehenAm']}')";
                $rs3 = $myDB->go($sql3);
            }
        }
        if ($_REQUEST['His_Usr'] == 1) {
        $sql = "ALTER TABLE $myDB->USERS ADD showUserName INT( 1 ) UNSIGNED NOT NULL DEFAULT '1' AFTER showSmallCovers";
        $rs = $myDB->go($sql);
        }
        if ($_REQUEST['His_Adm'] == 1) {
        $sql = "INSERT DELAYED IGNORE INTO $myDB->SETTINGS (Variable, Wert) VALUES ('showHistory', 'TRUE')";
        $rs = $myDB->go($sql);
        }

    if ( count( $myVar->warnung ) )
        unset($_REQUEST['sent']);
}


// Hier werden Ausgaben fr das Men gemacht
printHeader( $settings );
echo "<div id=\"seite\">";
printTopLogin( $myVar, $settings );

echo "<div id=\"untermenu\">";
echo "<ul>";

echo "</ul>";
echo "</div>";



if ( count( $myVar->warnung ) )
{
    echo "<ul class=\"message\" style=\"background-color:#f88\">";
    for ( $i=0; $i<count( $myVar->warnung ); ++$i )
        echo "<li>".$myVar->warnung[$i]."</li>";
    echo "</ul>";
}

if ( count( $myVar->hinweis ) )
{
    echo "<ul class=\"message\" style=\"background-color:#ffa\">";
    for ( $i=0; $i<count( $myVar->hinweis ); ++$i )
        echo "<li>".$myVar->hinweis[$i]."</li>";
    echo "</ul>";
}


echo "<div id=\"inhalt\">";
// Hier die Prfungen, wie de DB derzeit aussieht
$His = "1";
$His_Usr = "1";
$His_Adm = "1";
$sql = "SHOW TABLES FROM $dbase";
$rs = $myDB->go($sql);
while ( $row = $myDB->getRow($rs)) {

    if ( $row[Tables_in_.$dbase] == $myDB->HISTORY )  
        $His = "0";

    if ( $row[Tables_in_.$dbase] == $myDB->USERS ) {
        $sql4 = "SHOW COLUMNS FROM $myDB->USERS";
        $rs4 = $myDB->go($sql4);
        while ( $row4 = $myDB->getRow($rs4)) {
            if ( $row4[Field] == showUserName ) {
            $His_Usr = "0";
            }  
        }
    }

    if ( $row[Tables_in_.$dbase] == $myDB->SETTINGS ) {
        $sql3 = "SELECT Variable FROM $myDB->SETTINGS WHERE Variable = 'showHistory'";
        $rs3 = $myDB->go($sql3);
        $row3 = $myDB->getRow($rs3);
        if ($row3['Variable'] == showHistory) {
            $His_Adm = "0";
        }
    }    
}
if ($His == "0" && $His_Usr == "0" && $His_Adm == "0" ) {
    $no_install = TRUE;
} else {
    $no_install = FALSE;
}
if ($no_install) {
    echo "<p></p>";
    echo "<h2>INSTALLATIONSVERZEICHNIS VOM SERVER L&Ouml;SCHEN!</h2>";
    echo "Keine Installation bzw. Update ntig, da bereits die aktuellste Datenbankversion installiert ist.<br/>";
} else {
if ( !isset($_REQUEST['sent']) || count( $myVar->warnung ) )
{
    echo "<p><h2>Installationsskript des Mods: VerleihHistory 1.0</h2></p>";
    $sql = "SELECT VERSION() AS version";
    $rs = $myDB->go($sql);
    $row = $myDB->getRow($rs);
    echo "<p>MySQL-Version ist: ".$row['version'];
    if ( (float)$row['version'] < 4.1 ) {
        echo "<br />Es scheint so, als ob es eine alte Version ist. Beachte den Eintrag in der Datei 'admin.php'! Sonst kommt es zu Fehlermeldungen.";
    }
    echo "</p>";
    echo "<p><b>VOR DEM AUSFHREN DIESES SKRIPTES EINE SICHERHEITSKOPIE DER DATENBANK MACHEN !</b><br/><br/>Diese Script nimmt automatisch die ntigen nderungen in der Datanbank vor.  Es werden neue Tabellen erstellt, sowie eventuell vorhandene Tabellen abgendert. ";
    echo "<form method=\"post\" action=\"{$_SERVER['PHP_SELF']}\">";
    echo "<p>";
// Eventuelle Ausgaben fr bessere Verstndlichkeit was innerhalb des Skriptes passiert
    if($His == 1){
        $sql = "SELECT COUNT(*) AS anz FROM $myDB->DISCS WHERE ausgeliehenAm !='0000-00-00'";
        $rs = $myDB->go($sql);
        $row = $myDB->getRow($rs);
        echo "Die Tabelle fr die Verleihhistory ist nicht vorhanden und muss angelegt werden.";
        if($row['anz'] != 0)
            echo " Es erfolgt eine automatische Datenbernahme der derzeit verliehen Filme. Insgesamt werden {$row['anz']} Eintrge bertragen.<br/>";
        else
            echo "<br/>";
        echo "<input type=\"hidden\" name=\"His\" value=\"1\" />";
    }    
    if($His_Usr == 1){
        echo "Fr die Annonymittseinstellung der User muss eine neue Spalte zur Usertabelle hinzugefgt werden.<br/>";
        echo "<input type=\"hidden\" name=\"His_Usr\" value=\"1\" />";
    }    
    if($His_Adm == 1){
        echo "Auerdem muss fr die Konfiguration (abschaltabre History fr User) ein Eintrag in die Settings Tabelle gemacht werden.<br/>";
        echo "<input type=\"hidden\" name=\"His_Adm\" value=\"1\" />";
    }    
    echo "</p>";
    echo "<table>";
    echo "<tr>";
    echo "</table>";
    echo "<p><input type=\"hidden\" name=\"sent\" value=\"1\" /></p>";
    echo "<p style=\"margin-top:2em\"><input class=\"buttonSubmit\" type=\"submit\" name=\"sent\" value=\"Mod installieren\" /></p>";
    echo "</form>";
}
else
{
    echo "<p>Falls kein Fehler aufgetreten ist:</p>";
    echo "<h2>INSTALLATIONSVERZEICHNIS VOM SERVER L&Ouml;SCHEN!</h2>";
// Erluterung der gettigten AKtionen
    if ( isset($_REQUEST['sent']) ) {
        echo "<br/>";
        if ( $_REQUEST['His'] == 1 ) {
            echo "Die Tabelle fr die Verleihhistory wurde erfolgreich angelegt";
            if($row['anz'] !=0)
                echo " und es wurden {$row['anz']} Eintrge bernommen.<br/>";
            else
                echo ".<br/>";
        }
        if ( $_REQUEST['His_Usr'] == 1 ) {
            echo "Die neue Spalte wurde erfolgreich zu der Tabelle User hinzugefgt.<br/>";
        }
        if ( $_REQUEST['His_Adm'] == 1 ) {
            echo "Der Konfigurationseintrag fr die Verleihhistory wurde erfolgreich gesetzt.<br/>";
        }
    }
}
}
echo "</div>";
/*
 * COPYRIGHT-HINWEISE DRFEN NICHT VERNDERT WERDEN!
 * LINKS AUF WWW.DER-DOMI.DE MSSEN BESTEHEN BLEIBEN!
 */
printFootline($settings);
echo "</div>";
echo "</body></html>";


$out->put( $out->endBuffer() );


?>