<?php

/*******************************************
 *                                         *
 *     Filmverwaltung mit PHP & MySQL      *
 *                                         *
 *******************************************
 *                                         *
 * Copyright: ab 2005 Dominik Erdmann      *
 *  Internet: www.der-domi.de              *
 *     Email: kontakt@der-domi.de          *
 *                                         *
 *******************************************
 *                                         *
 * Das Skript darf nach eigenem Belieben   *
 * gendert werden. Copyright-Hinweise und *
 * Links auf www.der-domi.de drfen nicht  *
 * verndert werden und mssen jederzeit   *
 * sichtbar bleiben!                       *
 *                                         *
 *******************************************
 */

/*
 * Nachricht an Benutzer schicken
 */


if ( $_SESSION['UserRechte'] < 900 )
    exit();


if ( $myVar->MenuID == 894 )
{
    if ( $_SESSION['UserID'] != 1 )
        $myVar->hinweis[] = "Nur Superadmin mit ID 1 kann Settings &auml;ndern";
    else
    {
        // Falls die Demoinstallation aktiv ist, werden Server-Settings ausgeblendet
        if ( isset($demosystem) )
        {
            $settings->smtpHost = "";
            $settings->smtpPort = "";
            $settings->smtpUsername = "";
        }
        $settings->standardStyle = substr( $settings->standardStyle, 9 );
        
        
        echo "<form method=\"post\" action=\"{$_SERVER['PHP_SELF']}\">";
        echo "<table class=\"settings\">";
        echo "<tr>";
        echo "<td>&nbsp;</td>";
        echo "<td style=\"font-size:1.2em\">" .
                "<a href=\"http://demo.der-domi.de/filmverwaltung/docs/version.txt\">" .
                "<strong>Version: ".getVersion()."</strong></a>" .
             "</td>";
        echo "</tr>";
        echo "<tr>";
        echo "<td>&nbsp;</td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td>&nbsp;</td>";
        echo "<td><strong>Skripteinstellungen</strong></td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td class=\"description\">Browsertitel</td>";
        echo "<td><input style=\"width:20em\" type=\"text\" name=\"browserTitel\" value=\"$settings->browserTitel\" /></td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td class=\"description\">Skriptadresse</td>";
        echo "<td><input style=\"width:20em\" type=\"text\" name=\"skriptAdresse\" value=\"$settings->skriptAdresse\" />" .
                "<span style=\"font-size:0.8em\"> Adresse, unter der das Skript erreichbar ist. Nur eintragen, wenn lokal gesurft wird, Skript aber global auch erreichbar sein soll." .
                " Immer mit http:// angeben und ohne abschlie&szlig;enden &quot;/&quot;; nur Domain (kein Verzeichnis); z.B. &quot;http://filmdb.dyndns.org&quot;</span></td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td class=\"description\">zus&auml;tzlicher&nbsp;Topmenulink</td>";
        echo "<td><input style=\"width:20em\" type=\"text\" name=\"MenuLinkAdresse\" value=\"$settings->MenuLinkAdresse\" />" .
                "<span style=\"font-size:0.8em\"> mit http://</span></td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td class=\"description\">Name&nbsp;des&nbsp;Menulinks</td>";
        echo "<td><input style=\"width:20em\" type=\"text\" name=\"MenuLinkName\" value=\"$settings->MenuLinkName\" />" .
                "<span style=\"font-size:0.8em\"> optional</span></td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td class=\"description\">Standard&nbsp;Stylesheet</td>";
        echo "<td><input style=\"width:20em\" type=\"text\" name=\"standardStyle\" value=\"$settings->standardStyle\" /></td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td class=\"description\">Logout-Adresse</td>";
        echo "<td><input style=\"width:20em\" type=\"text\" name=\"logoutAdresse\" value=\"$settings->logoutAdresse\" />" .
                "<span style=\"font-size:0.8em\"> Diese Adresse (immer mit http:// angeben) wird beim Ausloggen aufgerufen. Wenn leer, dann Loginseite.</span></td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td class=\"description\">automatisches&nbsp;Login</td>";
        echo "<td>";
        echo "<select name=\"autoLogin\">";
        $sql = "SELECT * FROM $myDB->USERS ORDER BY UserName";
        $rs = $myDB->go($sql);
        
        echo "<option value=\"0\"";
        if ( $settings->autoLogin == 0 )
            echo "selected=\"selected\" style=\"font-weight:bold\"";
        echo ">deaktiviert</option>";
        
        while( $row = $myDB->getRow($rs) )
        {
            echo "<option value=\"{$row['UserID']}\"";
            if ( $row['UserID'] == $settings->autoLogin )
                echo "selected=\"selected\" style=\"font-weight:bold\"";
            echo ">{$row['UserName']} ({$row['Email']})</option>";
        }
        
        echo "</select>";
        echo "<span style=\"font-size:0.8em\"> Beim &Ouml;ffnen der Loginseite wird der Benutzer direkt als ausgew&auml;hlter Benutzer auf die Startseite geleitet.</span></td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td class=\"description\">Anmeldung&nbsp;folgen</td>";
        echo "<td><input type=\"checkbox\" class=\"checkbox\" style=\"width:1em\" name=\"skriptFolgen\" value=\"TRUE\" ";
        if ( $settings->skriptFolgen )
            echo ' checked="checked"';
        echo " /><span style=\"font-size:0.8em\"> Falls Benutzer angemeldet ist, wird er beim ffnen der Loginseite auf die Startseite geleitet.</span></td>";
        echo "</tr>";
        /*
        echo "<tr>";
        echo "<td class=\"description\">Skript&nbsp;in&nbsp;Frame&nbsp;starten</td>";
        echo "<td><input type=\"checkbox\" class=\"checkbox\" style=\"width:1em\" name=\"skriptInFrame\" value=\"TRUE\" ";
        if ( $settings->skriptInFrame )
            echo ' checked="checked"';
        echo " /><span style=\"font-size:0.8em\"> Das Skript wird beim Passwort-Check im Frame gestartet.</span></td>";
        echo "</tr>";
        */
        echo "<tr>";
        echo "<td class=\"description\">Exportname</td>";
        echo "<td><input style=\"width:20em\" type=\"text\" name=\"exportName\" value=\"".htmlentities($settings->exportName)."\" />" .
                "<span style=\"font-size:0.8em\"> Das PDF wird diesen Name haben. DATUM wird durch das aktuelle Datum ersetzt. " .
                "Falls ein Fehler beim Erstellen auftritt, kann eine lokale Datei angegeben werden. Dazu einfach Name mit einem Pfad angeben (z.B. ./Filme_DATUM oder ./tmp/Filme_DATUM).</span></td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td class=\"description\">Fusszeilenzusatz</td>";
        echo "<td><input style=\"width:20em\" type=\"text\" name=\"footlineAddOn\" value=\"".htmlentities($settings->footlineAddOn)."\" /></td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td class=\"description\">Datenbankbeschleunigung</td>";
        echo "<td><input type=\"checkbox\" class=\"checkbox\" style=\"width:1em\" name=\"dabaPerformance\" value=\"TRUE\" ";
        if ( $settings->dabaPerformance )
            echo ' checked="checked"';
        echo " /><span style=\"font-size:0.8em\"> Falls keine Privilegien oder FSK-Einschr&auml;nkungen benutzt werden, dann aktivieren. Beschleunigung der Datenbankabarbeitung f&uuml;r Benutzer.</span></td>";
        echo "</tr>";
        
        
        echo "<tr>";
        echo "<td>&nbsp;</td>";
        echo "<td>&nbsp;</td>";
        echo "</tr>";
        echo "<tr>";
        echo "<td>&nbsp;</td>";
        echo "<td><strong>Emaileinstellungen</strong></td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td class=\"description\">versende&nbsp;Emails</td>";
        echo "<td><input type=\"checkbox\" class=\"checkbox\" style=\"width:1em\" name=\"mailSend\" value=\"TRUE\" ";
        if ( $settings->mailSend )
            echo ' checked="checked"';
        echo " /><span style=\"font-size:0.8em\"> <strong>Achtung:</strong> Falls deaktiviert, werden Links zm &Auml;ndern " .
                "des Passworts direkt ausgegeben, damit die Funktion noch m&ouml;glich ist. Also nur zu Testzwecken verwenden!</span></td>";
        echo "</tr>";
        
        if ( $settings->mailSend )
        {
            echo "<tr>";
            echo "<td class=\"description\">Mailadresse</td>";
            echo "<td><input style=\"width:20em\" type=\"text\" name=\"mailFrom\" value=\"$settings->mailFrom\" /></td>";
            echo "</tr>";
            
            echo "<tr>";
            echo "<td class=\"description\">Name&nbsp;zur&nbsp;Mailadresse</td>";
            echo "<td><input style=\"width:20em\" type=\"text\" name=\"mailFromName\" value=\"$settings->mailFromName\" /></td>";
            echo "</tr>";
            
            echo "<tr>";
            echo "<td class=\"description\">Antwortmailadresse</td>";
            echo "<td><input style=\"width:20em\" type=\"text\" name=\"mailReplyTo\" value=\"$settings->mailReplyTo\" />" .
                    "<span style=\"font-size:0.8em\"> falls abweichend</span></td>";
            echo "</tr>";
            
            echo "<tr>";
            echo "<td class=\"description\">Name&nbsp;zur&nbsp;Antwortadresse</td>";
            echo "<td><input style=\"width:20em\" type=\"text\" name=\"mailReplyToName\" value=\"$settings->mailReplyToName\" /></td>";
            echo "</tr>";
            
            echo "<tr>";
            echo "<td class=\"description\">versende&nbsp;HTML-Mails</td>";
            echo "<td>";
            echo "<input type=\"radio\" class=\"checkbox\" name=\"mailHTML\" value=\"TRUE\" ";
            if ( $settings->mailHTML )
                echo ' checked="checked"';
            echo " /> ja";
            echo "<input style=\"margin-left:1em\" type=\"radio\" class=\"checkbox\" name=\"mailHTML\" value=\"FALSE\" ";
            if ( !$settings->mailHTML )
                echo ' checked="checked"';
            echo " /> nein, Text-Mail";
            echo "</td>";
            echo "</tr>";
            
            if ( !$settings->mailHTML )
            {
                echo "<tr>";
                echo "<td class=\"description\">Zeilenumbruch&nbsp;nach</td>";
                echo "<td><input style=\"width:2em\" type=\"text\" name=\"mailWordWrap\" value=\"$settings->mailWordWrap\" /> Zeichen</td>";
                echo "</tr>";
            }
            
            echo "<tr>";
            echo "<td class=\"description\">Versendeart</td>";
            echo "<td>";
            echo "<input type=\"radio\" class=\"checkbox\" name=\"mailSMTP\" value=\"TRUE\" ";
            if ( $settings->mailSMTP )
                echo ' checked="checked"';
            echo " /> per SMTP (empfohlen)";
            echo "<input style=\"margin-left:1em\" type=\"radio\" class=\"checkbox\" name=\"mailSMTP\" value=\"FALSE\" ";
            if ( !$settings->mailSMTP )
                echo ' checked="checked"';
            echo " /> per PHP";
            echo "</td>";
            echo "</tr>";
            
            if ( $settings->mailSMTP )
            {
                echo "<tr>";
                echo "<td class=\"description\">SMTP-Host</td>";
                echo "<td><input style=\"width:20em\" type=\"text\" name=\"smtpHost\" value=\"$settings->smtpHost\" /></td>";
                echo "</tr>";
                
                echo "<tr>";
                echo "<td class=\"description\">SMTP-Port</td>";
                echo "<td><input style=\"width:2em\" type=\"text\" name=\"smtpPort\" value=\"$settings->smtpPort\" /></td>";
                echo "</tr>";
                
                echo "<tr>";
                echo "<td class=\"description\">SMTP-Authentication</td>";
                echo "<td>";
                echo "<input type=\"radio\" class=\"checkbox\" name=\"smtpAuthentication\" value=\"TRUE\" ";
                if ( $settings->smtpAuthentication )
                    echo ' checked="checked"';
                echo " /> ja (empfohlen)";
                echo "<input style=\"margin-left:1em\" type=\"radio\" class=\"checkbox\" name=\"smtpAuthentication\" value=\"FALSE\" ";
                if ( !$settings->smtpAuthentication )
                    echo ' checked="checked"';
                echo " /> nein";
                echo "</td>";
                echo "</tr>";
                
                if ( $settings->smtpAuthentication )
                {
                    echo "<tr>";
                    echo "<td class=\"description\">SMTP-Username</td>";
                    echo "<td><input style=\"width:20em\" type=\"text\" name=\"smtpUsername\" value=\"$settings->smtpUsername\" /></td>";
                    echo "</tr>";
                    
                    echo "<tr>";
                    echo "<td class=\"description\">SMTP-Passwort</td>";
                    echo "<td><input style=\"width:20em\" type=\"password\" name=\"smtpPasswort\" />" .
                            "<span style=\"font-size:0.8em\"> <strong>Hinweis:</strong> Passwort wird als Klartext in der Datenbank gespeichert.</span></td>";
                    echo "</tr>";
                } // smtpAuthentication
            } // mailSMTP
        } // mailSend
        
        
        echo "<tr>";
        echo "<td>&nbsp;</td>";
        echo "<td>&nbsp;</td>";
        echo "</tr>";
        echo "<tr>";
        echo "<td>&nbsp;</td>";
        echo "<td><strong>Allgemeine Einstellungen</strong></td>";
        echo "</tr>";

        
        echo "<tr>";
        echo "<td class=\"description\">erste&nbsp;freie&nbsp;ID&nbsp;suchen</td>";
        echo "<td><input type=\"checkbox\" class=\"checkbox\" style=\"width:1em\" name=\"firstFitID\" value=\"TRUE\" ";
        if ( $settings->firstFitID )
            echo ' checked="checked"';
        echo " /><span style=\"font-size:0.8em\"> &Uuml;bersprungene ID's eines neuen Filmes werden wieder verwendet.</span></td>";
        echo "</tr>";

        echo "<tr>";
        echo "<td class=\"description\">Admin&nbsp;verleiht&nbsp;Filme</td>";
        echo "<td><input type=\"checkbox\" class=\"checkbox\" style=\"width:1em\" name=\"AdminCanDistribute\" value=\"TRUE\" ";
        if ( $settings->AdminCanDistribute )
            echo ' checked="checked"';
        echo " /><span style=\"font-size:0.8em\"> Nicht nur Superadmin.</span></td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td class=\"description\">Anzahl&nbsp;der&nbsp;Stellen&nbsp;einer&nbsp;ID</td>";
        echo "<td><input style=\"width:2em\" type=\"text\" name=\"anzStellenID\" value=\"$settings->anzStellenID\" /></td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td class=\"description\">Trennzeichen</td>";
        echo "<td><input style=\"width:2em\" type=\"text\" name=\"trennzeichen\" value=\"$settings->trennzeichen\" />" .
                "<span style=\"font-size:0.8em\"> Mit welchem Zeichen werden Namen von Schauspieler und Regisseure getrennt? Mit Vorsicht genie&szlig;en! Nicht mischen!</span></td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td class=\"description\">Anzahl&nbsp;Topfilme</td>";
        echo "<td><input style=\"width:2em\" type=\"text\" name=\"anzTopFilme\" value=\"$settings->anzTopFilme\" />" .
                "<span style=\"font-size:0.8em\"> auf Startseite</span></td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td class=\"description\">Anzahl&nbsp;neue&nbsp;Filme</td>";
        echo "<td><input style=\"width:2em\" type=\"text\" name=\"anzNeueFilme\" value=\"$settings->anzNeueFilme\" /></td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td class=\"description\">Anzahl&nbsp;beste&nbsp;Filme</td>";
        echo "<td><input style=\"width:2em\" type=\"text\" name=\"anzBestFilme\" value=\"$settings->anzBestFilme\" />" .
                "<span style=\"font-size:0.8em\"> Falls alle drei Anzahlen gleich Null, wird die Startseite ausgeblendet.</span></td>";
        echo "</tr>";
        
        echo "<tr>";
        echo "<td class=\"description\">erinnere&nbsp;Tage</td>";
        echo "<td><input style=\"width:2em\" type=\"text\" name=\"erinnereTage\" value=\"$settings->erinnereTage\" />" .
                "<span style=\"font-size:0.8em\"> Durch ein Cronjob wird der Benutzer nach diesen Tagen an ausgeliehene Filme erinnert." .
                " Es wird jedes ganzzahlige Vielfache wiederholt. Bei 0 wird nichts gesendet.</span></td>";
        echo "</tr>";




        echo "<tr>";
        echo "<td>&nbsp;</td>";
        echo "<td>&nbsp;</td>";
        echo "</tr>";
        echo "<tr>";
        echo "<td>&nbsp;</td>";
        echo "<td><strong>Mod Einstellungen</strong></td>";
        echo "</tr>";
        echo "<tr>";
        echo "<td></td>";
        echo "<td>";
        

        echo "<input type=\"checkbox\" class=\"checkbox\" style=\"width:1em\" name=\"showHistory\" value=\"TRUE\" ";
        if ( $settings->showHistory )
            echo ' checked="checked"';
        echo " /><span style=\"font-size:0.8em\">Benutzer knnen sehen, wer Film bereits ausgeliehen hat/hatte</span><br />";

        echo "</td>";
        echo "</tr>";

        
        
        echo "<tr>";
        echo "<td>&nbsp;</td>";
        echo "<td>&nbsp;</td>";
        echo "</tr>";
        echo "<tr>";
        echo "<td>&nbsp;</td>";
        echo "<td><strong>Informationen ein- und ausblenden</strong></td>";
        echo "</tr>";
        echo "<tr>";
        echo "<td></td>";
        echo "<td>";
        
        
        echo "<input type=\"checkbox\" class=\"checkbox\" style=\"width:1em\" name=\"showInfo\" value=\"TRUE\" ";
        if ( $settings->showInfo )
            echo ' checked="checked"';
        echo " /><span style=\"font-size:0.8em\">Info in Menu</span><br />";
        
        echo "<input type=\"checkbox\" class=\"checkbox\" style=\"width:1em\" name=\"showBesitzer\" value=\"TRUE\" ";
        if ( $settings->showBesitzer )
            echo ' checked="checked"';
        echo " /><span style=\"font-size:0.8em\">Besitzer des Filmes anzeigen</span><br />";
        
        echo "<input type=\"checkbox\" class=\"checkbox\" style=\"width:1em\" name=\"showDiscID\" value=\"TRUE\" ";
        if ( $settings->showDiscID )
            echo ' checked="checked"';
        echo " /><span style=\"font-size:0.8em\">DiskID des Filmes sichtbar</span><br />";
        
        
        echo "<input type=\"checkbox\" class=\"checkbox\" style=\"width:1em\" name=\"showFormat\" value=\"TRUE\" ";
        if ( $settings->showFormat )
            echo ' checked="checked"';
        echo " /><span style=\"font-size:0.8em\">Formatinformationen</span><br />";
        
        echo "<input type=\"checkbox\" class=\"checkbox\" style=\"width:1em\" name=\"showCollect\" value=\"TRUE\" ";
        if ( $settings->showCollect )
            echo ' checked="checked"';
        echo " /><span style=\"font-size:0.8em\">Kollektionsinformationen</span><br />";
        
        echo "<input type=\"checkbox\" class=\"checkbox\" style=\"width:1em\" name=\"adminSeeAll\" value=\"TRUE\" ";
        if ( $settings->adminSeeAll )
            echo ' checked="checked"';
        echo " /><span style=\"font-size:0.8em\">Admin sieht Formate, Kollektionen und DiskID's</span><br />";


        echo "<input type=\"checkbox\" class=\"checkbox\" style=\"width:1em\" name=\"showLoginStatus\" value=\"TRUE\" ";
        if ( $settings->showLoginStatus )
            echo ' checked="checked"';
        echo " /><span style=\"font-size:0.8em\">Logininformationen</span><br />";


        echo "<input type=\"checkbox\" class=\"checkbox\" style=\"width:1em\" name=\"showRating\" value=\"TRUE\" ";
        if ( $settings->showRating )
            echo ' checked="checked"';
        echo " /><span style=\"font-size:0.8em\">Benutzerbewertung des Films wird angezeigt.</span><br />";
        
        echo "</td>";
        echo "</tr>";
        
        
        echo "<tr>";
        echo "<td><p style=\"margin-top:3em\"></p></td>";
        echo "</tr>";
        echo "<tr>";
        echo "<td></td>";
        echo "<td colspan=\"2\"><input class=\"buttonSubmit\" type=\"submit\" name=\"sent\" value=\"&auml;ndern\" />";
        
        echo $myVar->getRequest("",TRUE);
        echo "</td>";
        echo "</tr>";
        
        echo "</table>";
        echo "</form>";
    }
}
?>
